build: fixed a typo that prevented --bundled-libraries from working correctly
[samba.git] / buildtools / wafsamba / samba_bundled.py
1 # functions to support bundled libraries
2
3 from Configure import conf
4 import Logs
5 from samba_utils import *
6
7 def BUNDLED_NAME(bld, name, bundled_extension):
8     '''possibly rename a library to include a bundled extension'''
9     if bld.env.DISABLE_SHARED or not bundled_extension:
10         return name
11     if name in bld.env.BUNDLED_EXTENSION_EXCEPTION:
12         return name
13     extension = getattr(bld.env, 'BUNDLED_EXTENSION', '')
14     if extension:
15         return name + '-' + extension
16     return name
17
18
19 def target_in_list(target, lst, default):
20     for l in lst:
21         if target == l:
22             return True
23         if '!' + target == l:
24             return False
25         if l == 'ALL':
26             return True
27         if l == 'NONE':
28             return False
29     return default
30
31
32 def BUILTIN_LIBRARY(bld, name):
33     '''return True if a library should be builtin
34        instead of being built as a shared lib'''
35     if bld.env.DISABLE_SHARED:
36         return True
37     return target_in_list(name, bld.env.BUILTIN_LIBRARIES, False)
38
39
40 def BUILTIN_DEFAULT(opt, builtins):
41     '''set a comma separated default list of builtin libraries for this package'''
42     if 'BUILTIN_LIBRARIES_DEFAULT' in Options.options:
43         return
44     Options.options['BUILTIN_LIBRARIES_DEFAULT'] = builtins
45 Options.Handler.BUILTIN_DEFAULT = BUILTIN_DEFAULT
46
47
48 def BUNDLED_EXTENSION_DEFAULT(opt, extension, noextenion=''):
49     '''set a default bundled library extension'''
50     if 'BUNDLED_EXTENSION_DEFAULT' in Options.options:
51         return
52     Options.options['BUNDLED_EXTENSION_DEFAULT'] = extension
53     Options.options['BUNDLED_EXTENSION_EXCEPTION'] = noextenion
54 Options.Handler.BUNDLED_EXTENSION_DEFAULT = BUNDLED_EXTENSION_DEFAULT
55
56
57 def minimum_library_version(conf, libname, default):
58     '''allow override of mininum system library version'''
59
60     minlist = Options.options.MINIMUM_LIBRARY_VERSION
61     if not minlist:
62         return default
63
64     for m in minlist.split(','):
65         a = m.split(':')
66         if len(a) != 2:
67             Logs.error("Bad syntax for --minimum-library-version of %s" % m)
68             sys.exit(1)
69         if a[0] == libname:
70             return a[1]
71     return default
72
73
74 @runonce
75 @conf
76 def CHECK_BUNDLED_SYSTEM(conf, libname, minversion='0.0.0',
77                          checkfunctions=None, headers=None,
78                          onlyif=None, implied_deps=None,
79                          require_headers=True):
80     '''check if a library is available as a system library.
81     this first tries via pkg-config, then if that fails
82     tries by testing for a specified function in the specified lib
83     '''
84     if 'ALL' in conf.env.BUNDLED_LIBS or libname in conf.env.BUNDLED_LIBS:
85         return False
86     found = 'FOUND_SYSTEMLIB_%s' % libname
87     if found in conf.env:
88         return conf.env[found]
89
90     # see if the library should only use a system version if another dependent
91     # system version is found. That prevents possible use of mixed library
92     # versions
93     if onlyif:
94         for syslib in TO_LIST(onlyif):
95             f = 'FOUND_SYSTEMLIB_%s' % syslib
96             if not f in conf.env:
97                 if 'NONE' in conf.env.BUNDLED_LIBS or '!'+libname in conf.env.BUNDLED_LIBS:
98                     Logs.error('ERROR: Use of system library %s depends on missing system library %s' % (libname, syslib))
99                     sys.exit(1)
100                 conf.env[found] = False
101                 return False
102
103     minversion = minimum_library_version(conf, libname, minversion)
104
105     # try pkgconfig first
106     if conf.check_cfg(package=libname,
107                       args='"%s >= %s" --cflags --libs' % (libname, minversion),
108                       msg='Checking for system %s >= %s' % (libname, minversion)):
109         conf.SET_TARGET_TYPE(libname, 'SYSLIB')
110         conf.env[found] = True
111         if implied_deps:
112             conf.SET_SYSLIB_DEPS(libname, implied_deps)
113         return True
114     if checkfunctions is not None:
115         headers_ok = True
116         if require_headers and headers and not conf.CHECK_HEADERS(headers):
117             headers_ok = False
118         if headers_ok and conf.CHECK_FUNCS_IN(checkfunctions, libname, headers=headers, empty_decl=False):
119             conf.env[found] = True
120             if implied_deps:
121                 conf.SET_SYSLIB_DEPS(libname, implied_deps)
122             return True
123     conf.env[found] = False
124     if 'NONE' in conf.env.BUNDLED_LIBS or '!'+libname in conf.env.BUNDLED_LIBS:
125         Logs.error('ERROR: System library %s of version %s not found, and bundling disabled' % (libname, minversion))
126         sys.exit(1)
127     return False
128